#ifndef LAYER_MODEL_H
#define LAYER_MODEL_H

#include <QQuickView>
#include <QStandardItemModel>
#include "controller.h"

using namespace Carmenta::Engine;

Q_DECLARE_METATYPE(LayerPtr)
// Model class inheriting from QStandardItemModel.
class LayerModel : public QStandardItemModel
{
	Q_OBJECT

public:
	void initialize();

	Q_INVOKABLE void onCheckedChanged(const QModelIndex& index, const bool checked);
	Q_INVOKABLE bool isChecked(QModelIndex index);

	enum LayerModelRoles{
		LayerRole = Qt::UserRole + 1,
		TreeIndexRole
	};

protected:
	 virtual QHash<int, QByteArray> roleNames() const;

private:
	void addChildLayerNodes(LayerCollectionPtr layerSet, QStandardItem* rootNode);
};


#endif
