#ifndef TACTICAL_SYMBOLS_MODEL_H
#define TACTICAL_SYMBOLS_MODEL_H

#include <QQuickView>
#include <QAbstractListModel>
#include <QQuickImageProvider>
#include "controller.h"
#include "tacticalsymbolitem.h"

using namespace Carmenta::Engine;


class TacticalSymbolsModel : public QAbstractListModel
{
	Q_OBJECT

public:
    TacticalSymbolsModel(QObject* parent = 0);

    // Basic functionality:
    int rowCount(const QModelIndex& parent = QModelIndex()) const override;
    QVariant data(const QModelIndex& index, int role = Qt::DisplayRole) const override;

    // Returns the sidc corresponding to the element at index index
	Q_INVOKABLE QString getSidcFromIndex(int index);

    // Image provider functionality
    Q_INVOKABLE QUrl requestImage(const int id);

private:
    // Internal container of images / sidc for a given index
    QList<TacticalSymbolItem> _symbols;

};

#endif
